Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.xml
Class QXmlStreamWriter

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.xml.QXmlStreamWriter

All Implemented Interfaces:
  QtJambiInterface

    public class QXmlStreamWriter

extends QtJambiObject

The `QXmlStreamWriter` class provides an XML writer with a simple streaming API. `QXmlStreamWriter` is the pendent to `QXmlStreamReader` for writing XML. Like its related class, it operates on a `QIODevice` specified with `setDevice()`. The API is simple and straight forward: For every XML token or event you want to write, the writer provides a specialized function.

You start a document with `writeStartDocument()` and end it with `writeEndDocument()`. This will implicitly close all remaining open tags.

Element tags are opened with `writeStartElement()` followed by `writeAttribute()` or `writeAttributes()`, element content, and then `writeEndElement()`. A shorter form `writeEmptyElement()` can be used to write empty elements, followed by `writeAttributes()`.

Element content consists of either characters, entity references or nested elements. It is written with `writeCharacters()`, which also takes care of escaping all forbidden characters and character sequences, `writeEntityReference()`, or subsequent calls to `writeStartElement()`. A convenience method `writeTextElement()` can be used for writing terminal elements that contain nothing but text.

`QXmlStreamWriter` takes care of prefixing namespaces, all you have to do is specify the `namespaceUri` when writing elements or attributes. If you must conform to certain prefixes, you can force the writer to use them by declaring the namespaces manually with either `writeNamespace()` or `writeDefaultNamespace()`. Alternatively, you can bypass the stream writer's namespace support and use overloaded methods that take a qualified name instead. The namespace http://www.w3.org/XML/1998/namespace is implicit and mapped to the prefix xml.

The stream writer can automatically format the generated XML data by adding line-breaks and indentation to empty sections between elements, making the XML data more readable for humans and easier to work with for most source code management systems. The feature can be turned on with the `autoFormatting` property, and customized with the `autoFormattingIndent` property.

Other functions are `writeCDATA()`, `writeComment()`, `writeProcessingInstruction()`, and `writeDTD()`. Chaining of XML streams is supported with `writeCurrentToken()`.

By default, `QXmlStreamWriter` encodes XML in UTF-8. Different encodings can be enforced using `setCodec()`.

The QXmlStream Bookmarks Example illustrates how to use a subclassed stream writer to write an XML bookmark file (XBEL) that was previously read in by a `QXmlStreamReader`.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QXmlStreamWriter()` Constructs a stream writer.
`QXmlStreamWriter(QByteArray array)` Constructs a stream writer that writes into `array`.
`QXmlStreamWriter(QIODevice device)` Constructs a stream writer that writes into `device`;

Method Summary
`boolean` | `autoFormatting()` the auto-formatting flag of the stream writer
`int` | `autoFormattingIndent()` This property holds the number of spaces used for indentation when auto-formatting is enabled.
`QTextCodec` | `codec()` Returns the codec that is currently assigned to the stream.
`QIODevice` | `device()` Returns the current device associated with the `QXmlStreamWriter`, or 0 if no device has been assigned.
`void` | `setAutoFormatting(boolean arg__1)` the auto-formatting flag of the stream writer
`void` | `setAutoFormattingIndent(int spaces)` This property holds the number of spaces used for indentation when auto-formatting is enabled.
`void` | `setCodec(QTextCodec codec)` Sets the codec for this stream to `codec`.
`void` | `setCodec(java.lang.String codecName)` Sets the codec for this stream to the QTextCodec for the encoding specified by `codecName`.
`void` | `setDevice(QIODevice device)` Sets the current device to `device`.
`void` | `writeAttribute(QXmlStreamAttribute attribute)` Writes the `attribute`.
`void` | `writeAttribute(java.lang.String qualifiedName, java.lang.String value)` Writes an attribute with `qualifiedName` and `value`.
`void` | `writeAttribute(java.lang.String namespaceUri, java.lang.String name, java.lang.String value)` Writes an attribute with `name` and `value`, prefixed for the specified `namespaceUri`.
`void` | `writeAttributes(QXmlStreamAttributes attributes)` Writes the attribute vector `attributes`.
`void` | `writeCDATA(java.lang.String text)` Writes `text` as CDATA section.
`void` | `writeCharacters(java.lang.String text)` Writes `text`.
`void` | `writeComment(java.lang.String text)` Writes `text` as XML comment, where `text` must not contain the forbidden sequence "--" or end with "-".
`void` | `writeCurrentToken(QXmlStreamReader reader)` Writes the current state of the `reader`.
`void` | `writeDefaultNamespace(java.lang.String namespaceUri)` Writes a default namespace declaration for `namespaceUri`.
`void` | `writeDTD(java.lang.String dtd)` Writes a DTD section.
`void` | `writeEmptyElement(java.lang.String qualifiedName)` Writes an empty element with qualified name `qualifiedName`.
`void` | `writeEmptyElement(java.lang.String namespaceUri, java.lang.String name)` Writes an empty element with `name`, prefixed for the specified `namespaceUri`.
`void` | `writeEndDocument()` Closes all remaining open start elements and writes a newline.
`void` | `writeEndElement()` Closes the previous start element.
`void` | `writeEntityReference(java.lang.String name)` Writes the entity reference `name` to the stream, as "&`name`;".
`void` | `writeNamespace(java.lang.String namespaceUri)` Writes a namespace declaration for `namespaceUri` with `prefix`.
`void` | `writeNamespace(java.lang.String namespaceUri, java.lang.String prefix)` Writes a namespace declaration for `namespaceUri` with `prefix`.
`void` | `writeProcessingInstruction(java.lang.String target)` Writes an XML processing instruction with `target` and `data`, where `data` must not contain the sequence "?>".
`void` | `writeProcessingInstruction(java.lang.String target, java.lang.String data)` Writes an XML processing instruction with `target` and `data`, where `data` must not contain the sequence "?>".
`void` | `writeStartDocument()` Writes a document start with XML version number "1.0"
`void` | `writeStartDocument(java.lang.String version)` Writes a document start with the XML version number `version`.
`void` | `writeStartElement(java.lang.String qualifiedName)` Writes a start element with `qualifiedName`.
`void` | `writeStartElement(java.lang.String namespaceUri, java.lang.String name)` Writes a start element with `name`, prefixed for the specified `namespaceUri`.
`void` | `writeTextElement(java.lang.String qualifiedName, java.lang.String text)` Writes a text element with `qualifiedName` and `text`.
`void` | `writeTextElement(java.lang.String namespaceUri, java.lang.String name, java.lang.String text)` Writes a text element with `name`, prefixed for the specified `namespaceUri`, and `text`.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QXmlStreamWriter

    public QXmlStreamWriter()

  Constructs a stream writer.

See also:
  `setDevice()`.

### QXmlStreamWriter

    public QXmlStreamWriter(QIODevice device)

  Constructs a stream writer that writes into `device`;

### QXmlStreamWriter

    public QXmlStreamWriter(QByteArray array)

  Constructs a stream writer that writes into `array`. This is the same as creating an xml writer that operates on a QBuffer device which in turn operates on `array`.

Method Detail

### autoFormatting

    public final boolean autoFormatting()

  the auto-formatting flag of the stream writer

  This property controls whether or not the stream writer automatically formats the generated XML data. If enabled, the writer automatically adds line-breaks and indentation to empty sections between elements (ignorable whitespace). The main purpose of auto-formatting is to split the data into several lines, and to increase readability for a human reader. The indentation depth can be controlled through the `autoFormattingIndent` property.

  By default, auto-formatting is disabled.

### autoFormattingIndent

    public final int autoFormattingIndent()

  This property holds the number of spaces used for indentation when auto-formatting is enabled. The default indentation is 4.

See also:
  `autoFormatting`.

### codec

    public final QTextCodec codec()

  Returns the codec that is currently assigned to the stream.

See also:
  `setCodec()`.

### device

    public final QIODevice device()

  Returns the current device associated with the `QXmlStreamWriter`, or 0 if no device has been assigned.

See also:
  `setDevice()`.

### setAutoFormatting

    public final void setAutoFormatting(boolean arg__1)

  the auto-formatting flag of the stream writer

  This property controls whether or not the stream writer automatically formats the generated XML data. If enabled, the writer automatically adds line-breaks and indentation to empty sections between elements (ignorable whitespace). The main purpose of auto-formatting is to split the data into several lines, and to increase readability for a human reader. The indentation depth can be controlled through the `autoFormattingIndent` property.

  By default, auto-formatting is disabled.

### setAutoFormattingIndent

    public final void setAutoFormattingIndent(int spaces)

  This property holds the number of spaces used for indentation when auto-formatting is enabled. The default indentation is 4.

See also:
  `autoFormatting`.

### setCodec

    public final void setCodec(QTextCodec codec)

  Sets the codec for this stream to `codec`. The codec is used for encoding any data that is written. By default, `QXmlStreamWriter` uses UTF-8.

See also:
  `codec()`.

### setDevice

    public final void setDevice(QIODevice device)

  Sets the current device to `device`. If you want the stream to write into a `QByteArray`, you can create a `QBuffer` device.

See also:
  `device()`.

### writeAttribute

    public final void writeAttribute(java.lang.String namespaceUri,
                                     java.lang.String name,
                                     java.lang.String value)

  Writes an attribute with `name` and `value`, prefixed for the specified `namespaceUri`. If the namespace has not been declared yet, `QXmlStreamWriter` will generate a namespace declaration for it.

  This function can only be called after `writeStartElement()` before any content is written, or after `writeEmptyElement()`.

### writeAttribute

    public final void writeAttribute(java.lang.String qualifiedName,
                                     java.lang.String value)

  Writes an attribute with `qualifiedName` and `value`.

  This function can only be called after `writeStartElement()` before any content is written, or after `writeEmptyElement()`.

### writeAttribute

    public final void writeAttribute(QXmlStreamAttribute attribute)

  Writes the `attribute`.

  This function can only be called after `writeStartElement()` before any content is written, or after `writeEmptyElement()`.

### writeAttributes

    public final void writeAttributes(QXmlStreamAttributes attributes)

  Writes the attribute vector `attributes`. If a namespace referenced in an attribute not been declared yet, `QXmlStreamWriter` will generate a namespace declaration for it.

  This function can only be called after `writeStartElement()` before any content is written, or after `writeEmptyElement()`.

See also:
  `writeAttribute()`, and `writeNamespace()`.

### writeCDATA

    public final void writeCDATA(java.lang.String text)

  Writes `text` as CDATA section. If `text` contains the forbidden character sequence "]]>", it is split into different CDATA sections.

  This function mainly exists for completeness. Normally you should not need use it, because `writeCharacters()` automatically escapes all non-content characters.

### writeCharacters

    public final void writeCharacters(java.lang.String text)

  Writes `text`. The characters "<", "&", and """ are escaped as entity references "<", "&, and """. To avoid the forbidden sequence "]]>", ">" is also escaped as ">".

See also:
  `writeEntityReference()`.

### writeComment

    public final void writeComment(java.lang.String text)

  Writes `text` as XML comment, where `text` must not contain the forbidden sequence "--" or end with "-". Note that XML does not provide any way to escape "-" in a comment.

### writeCurrentToken

    public final void writeCurrentToken(QXmlStreamReader reader)

  Writes the current state of the `reader`. All possible valid states are supported.

  The purpose of this function is to support chained processing of XML data.

See also:
  `QXmlStreamReader::tokenType()`.

### writeDTD

    public final void writeDTD(java.lang.String dtd)

  Writes a DTD section. The `dtd` represents the entire doctypedecl production from the XML 1.0 specification.

### writeDefaultNamespace

    public final void writeDefaultNamespace(java.lang.String namespaceUri)

  Writes a default namespace declaration for `namespaceUri`.

  If `writeStartElement()` or `writeEmptyElement()` was called, the declaration applies to the current element; otherwise it applies to the next child element.

  Note that the namespaces http://www.w3.org/XML/1998/namespace (bound to xmlns) and http://www.w3.org/2000/xmlns/ (bound to xml) by definition cannot be declared as default.

### writeEmptyElement

    public final void writeEmptyElement(java.lang.String namespaceUri,
                                        java.lang.String name)

  Writes an empty element with `name`, prefixed for the specified `namespaceUri`. If the namespace has not been declared, `QXmlStreamWriter` will generate a namespace declaration for it. Subsequent calls to `writeAttribute()` will add attributes to this element.

See also:
  `writeNamespace()`.

### writeEmptyElement

    public final void writeEmptyElement(java.lang.String qualifiedName)

  Writes an empty element with qualified name `qualifiedName`. Subsequent calls to `writeAttribute()` will add attributes to this element.

### writeEndDocument

    public final void writeEndDocument()

  Closes all remaining open start elements and writes a newline.

See also:
  `writeStartDocument()`.

### writeEndElement

    public final void writeEndElement()

  Closes the previous start element.

See also:
  `writeStartElement()`.

### writeEntityReference

    public final void writeEntityReference(java.lang.String name)

  Writes the entity reference `name` to the stream, as "&`name`;".

### writeNamespace

    public final void writeNamespace(java.lang.String namespaceUri)

  Writes a namespace declaration for `namespaceUri` with `prefix`. If `prefix` is empty, `QXmlStreamWriter` assigns a unique prefix consisting of the letter 'n' followed by a number.

  If `writeStartElement()` or `writeEmptyElement()` was called, the declaration applies to the current element; otherwise it applies to the next child element.

  Note that the prefix xml is both predefined and reserved for http://www.w3.org/XML/1998/namespace, which in turn cannot be bound to any other prefix. The prefix xmlns and its URI http://www.w3.org/2000/xmlns/ are used for the namespace mechanism itself and thus completely forbidden in declarations.

### writeNamespace

    public final void writeNamespace(java.lang.String namespaceUri,
                                     java.lang.String prefix)

  Writes a namespace declaration for `namespaceUri` with `prefix`. If `prefix` is empty, `QXmlStreamWriter` assigns a unique prefix consisting of the letter 'n' followed by a number.

  If `writeStartElement()` or `writeEmptyElement()` was called, the declaration applies to the current element; otherwise it applies to the next child element.

  Note that the prefix xml is both predefined and reserved for http://www.w3.org/XML/1998/namespace, which in turn cannot be bound to any other prefix. The prefix xmlns and its URI http://www.w3.org/2000/xmlns/ are used for the namespace mechanism itself and thus completely forbidden in declarations.

### writeProcessingInstruction

    public final void writeProcessingInstruction(java.lang.String target)

  Writes an XML processing instruction with `target` and `data`, where `data` must not contain the sequence "?>".

### writeProcessingInstruction

    public final void writeProcessingInstruction(java.lang.String target,
                                                 java.lang.String data)

  Writes an XML processing instruction with `target` and `data`, where `data` must not contain the sequence "?>".

### writeStartDocument

    public final void writeStartDocument()

  Writes a document start with XML version number "1.0"

See also:
  `writeEndDocument()`.

### writeStartDocument

    public final void writeStartDocument(java.lang.String version)

  Writes a document start with the XML version number `version`.

See also:
  `writeEndDocument()`.

### writeStartElement

    public final void writeStartElement(java.lang.String namespaceUri,
                                        java.lang.String name)

  Writes a start element with `name`, prefixed for the specified `namespaceUri`. If the namespace has not been declared yet, `QXmlStreamWriter` will generate a namespace declaration for it. Subsequent calls to `writeAttribute()` will add attributes to this element.

See also:
  `writeNamespace()`, `writeEndElement()`, and `writeEmptyElement()`.

### writeStartElement

    public final void writeStartElement(java.lang.String qualifiedName)

  Writes a start element with `qualifiedName`. Subsequent calls to `writeAttribute()` will add attributes to this element.

See also:
  `writeEndElement()`, and `writeEmptyElement()`.

### writeTextElement

    public final void writeTextElement(java.lang.String namespaceUri,
                                       java.lang.String name,
                                       java.lang.String text)

  Writes a text element with `name`, prefixed for the specified `namespaceUri`, and `text`. If the namespace has not been declared, `QXmlStreamWriter` will generate a namespace declaration for it.

  This is a convenience function equivalent to:

              writeStartElement(namespaceUri, name);
              writeCharacters(text);
              writeEndElement();

### writeTextElement

    public final void writeTextElement(java.lang.String qualifiedName,
                                       java.lang.String text)

  Writes a text element with `qualifiedName` and `text`.

  This is a convenience function equivalent to:

              writeStartElement(qualifiedName);
              writeCharacters(text);
              writeEndElement();

### setCodec

    public final void setCodec(java.lang.String codecName)

  Sets the codec for this stream to the QTextCodec for the encoding specified by `codecName`. Common values for \c codecName include "ISO 8859-1", "UTF-8", and "UTF-16". If the encoding isn't recognized, nothing happens.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD